//+------------------------------------------------------------------+
//|                   market_order_ecn_80_800_v5_teste_mm_sl_v10.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""


 //+------------------------------------------------------------------------------------------------------------------+ 
// External Variables

extern string UserSettings        = "=== User Settings ===";
extern bool   DynamicLotSize      = false;
extern double PercentageToTrade   =   1;
extern double FixedLotSize        = 0.01;
extern double Multiplier          =   4;
extern int    MagicNumber         =  10;
extern string LimitsSettings      = "=== Limits Settings ===";
extern double StopLoss            =  50;
extern double TakeProfit          =  50;
extern double MinimumProfit       = 1.7;
extern int    Slippage            =   1;
extern int    OpenDistance        =   0;
extern int    OppositeDistance    =   2; 
extern double MinStop             =   1;
extern int    MaxOrders           =   8;
extern string TimeSettings        = "=== Time Settings ===";
extern int    StartHourOnSunday   =  21;
extern int    LastHourOnFriday    =  21;
extern int    StartToClose        =  20;
extern int    CloseMarketOnFriday =  21;
    
 //+------------------------------------------------------------------------------------------------------------------+ 
// Global Variables

int BuyTicket,SellTicket;
int OTCurrentTick, OTLastTick;
double LotSize,LastLot,MLots;
double BuyTrigger,SellTrigger;
bool BuyAllowed = true,SellAllowed = true;
int  pips2points,Digits.pips; 
double  pips2dbl,lotmin,lotmax,lotstep,RiskAmount,MMLots,LastOrderProfit,TotalOrderCommission,TotalOrderSwap,CumulativeProfit;

 //+------------------------------------------------------------------------------------------------------------------+ 
 int init ()// Adjust for 4 or 5 digits.
   {
    if (Digits == 5 || Digits == 3)
       {    
        pips2dbl = Point*10; pips2points = 10; Digits.pips = 1; 
       }
    else 
       {   
        pips2dbl = Point; pips2points =  1; Digits.pips = 0;   
       }
           
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      
   //+------------------------------------------------------------------------------------------------------------------+      
  // Get Current Market Status of the EA
  
   int LastClosedTicket = GetTicketFromHistory(Symbol(),MagicNumber);
     
   if(LastClosedTicket > 0)
    {                                                                 
      Print("LastClosedTicket=",LastClosedTicket);                   
      if(OrderSelect(LastClosedTicket,SELECT_BY_TICKET))                 
       {            
         if(OrderType()== OP_BUY)
         {
         BuyAllowed = false;SellAllowed = true;
         } 
         else                   
         {
         BuyAllowed = true;SellAllowed = false;
         } 
       }   
     }                
 return(0);   
   }
 
   //+------------------------------------------------------------------------------------------------------------------+ 
 int start()
 
   {//0 
    	         	 		 
    OTLastTick = OTCurrentTick;                      
    OTCurrentTick = OrdersTotal(); 
                     
    if(OTCurrentTick == 0 && OTLastTick > 0)
      {      
      BuyTrigger = Ask + OpenDistance * pips2dbl;
      SellTrigger = Bid - OpenDistance * pips2dbl;
      }             
    //if(OTCurrentTick > 0) Trail();                   
    if(OTLastTick >= 2                                                
      && OTCurrentTick < OTLastTick
      && OTCurrentTick > 0)
      {
      CloseAllOnSL();return;
      }                                                                  
    if(OTCurrentTick > 0 && OTCurrentTick < MaxOrders) OpenOppositeOrder();   
    //if(OTCurrentTick > 0 && OTCurrentTick == MaxOrders && LastOrderProfit <= OrderOpenPrice() - 0.00002 * pips2dbl) CloseAll();
             
    if(DayOfWeek() == 5 && Hour() >= CloseMarketOnFriday)CloseAll();
                     
    if(OTCurrentTick == 0)
      {
       BuyAllowed = true;  
       
       SellAllowed = true; 
       
   //+------------------------------------------------------------------------------------------------------------------+   
  //Money Management 
  
    if(DynamicLotSize == true)
      {//1
      double RiskAmount = AccountBalance() * (PercentageToTrade / 100000);
     
      LotSize = RiskAmount;
      }//1
    else LotSize = FixedLotSize;
             
   //+------------------------------------------------------------------------------------------------------------------+      
  // Lot size verification 
      {
       lotmin = MarketInfo(Symbol(),MODE_MINLOT);
       lotmax = MarketInfo(Symbol(),MODE_MAXLOT);
       lotstep = MarketInfo(Symbol(),MODE_LOTSTEP);
                    
       LotSize = MathFloor(LotSize/lotstep) * lotstep;
     
       if(LotSize < lotmin)
        LotSize = lotmin;
       if(LotSize > lotmax)
        LotSize = lotmax;             
      }             
  
   //+------------------------------------------------------------------------------------------------------------------+                                                                                                                                                                                                                                                                                                                                                                            
  // Initial Buy Order Condition to Open
  
      RefreshRates();
   if(Ask > BuyTrigger && BuyAllowed)     
	  {//5
	  	if (TradingHours() == true)
	  while(IsTradeContextBusy()) 
	        Sleep(10);
	        RefreshRates();	  		       
     BuyTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage*pips2points,0,0,"Initial Buy Order",MagicNumber,0,Green);                
     if(BuyTicket > -1)
        {//6
         BuyAllowed = false;SellAllowed = true;                                               
         Print("Initial Buy order placed # ",BuyTicket);
         AddLimitsBuy();                 
         }//6
      else
         {//7 
         Print("Initial Buy Order Send failed, order number:",OrderTicket(),"Error:", GetLastError());
         }//7 
     return(0);
     }//5
     
   //+------------------------------------------------------------------------------------------------------------------+ 	  
  // Initial Sell Order Condition to Open
  
       RefreshRates();
    if( Bid < SellTrigger && SellAllowed)                       
     {//8
     if (TradingHours() == true)                                 
	  while(IsTradeContextBusy()) 
	        Sleep(10);
	        RefreshRates();					 		
	  SellTicket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage*pips2points,0,0,"Initial Sell Order",MagicNumber,0,Red);	  
	  if(SellTicket > -1)
 		  {//9
 		  BuyAllowed = true;SellAllowed = false;                                                 
        Print("Initial Sell order placed # ", SellTicket);
        AddLimitsSell();
        }//9
     else
        {//10
        Print("Initial Sell Order Send failed, order number:",OrderTicket(),"Error:", GetLastError());
        }//10      
     return(0);
     }//8          
  }//
  				 				
    //+------------------------------------------------------------------------------------------------------------------+   
   // Order loss compensation 
   
   
   MLots = 0;
   for(int cnt = OrdersTotal()-1; cnt >= 0; cnt--)
      {//11
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))continue;
         {//12
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
            {//13 
            LastOrderProfit = OrderProfit();            
             OrderLots();
         if(MLots <= OrderLots())MLots = NormalizeDouble(OrderLots() * Multiplier,2);                                                    
            }//13
         }//12      
      }//11
         if(LastOrderProfit > 0)Trail();          
   return(0);
   }//0 
                         
   //+------------------------------------------------------------------------------------------------------------------+ 
  //Add limits after sent order for ECN Brokers)   

   void  AddLimitsBuy()
      {
      OrderSelect(BuyTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();
      
   // Calculate Stop Level Limits
        
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
           
      RefreshRates();      				       				            
      double UpperStopLevel = Ask + StopLevel;
      double LowerStopLevel = Bid - StopLevel;
            
   // Calculate Stop Loss and Take Profit Limits
      
      if(StopLoss > 0)double BuyStopLoss = OpenPrice - (StopLoss * pips2dbl); 
      if(TakeProfit > 0)double BuyTakeProfit = OpenPrice + (TakeProfit * pips2dbl);
      
   // Verify Sto Loss and Take Profit Minimum Limits 
      
      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel)
        {
          BuyStopLoss = LowerStopLevel - MinStop * pips2dbl;
        }
    //  Buy Order Send Stop Loss and Take Profit
          				      	   
	   if(IsTradeContextBusy())
	      Sleep(10);	
      if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
        {		
        if(!OrderModify(BuyTicket,OpenPrice,BuyStopLoss,BuyTakeProfit,0))
        Print("AddLimitsBuy Failed,order number:",OrderTicket(),"Error:",GetLastError());                            
        }
      } 
    //+------------------------------------------------------------------------------------------------------------------+ 
   //Add limits after sent order (ECN Brokers)   

   void   AddLimitsSell()
      {
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();
      
    // Calculate Stop Level Limits 
     
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
             
	   RefreshRates();
	   double UpperStopLevel = Ask + StopLevel;
	   double LowerStopLevel = Bid - StopLevel;	   
	   
	// Calculate Stop Loss and Take Profit Limits 
	  				      				      
	   if(StopLoss > 0) double SellStopLoss = OpenPrice + (StopLoss * pips2dbl);
	   if(TakeProfit > 0) double SellTakeProfit = OpenPrice - (TakeProfit * pips2dbl);
	   
	// Verify Stop Loss and Take Profit Minimum Limits 
	 
	   if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel)
	     {
	       double SellStopLevel = UpperStopLevel + MinStop * pips2dbl;
	     }
	 //  Sell Order Send Stop loss and Take Profit 
	         					      
	   if(IsTradeContextBusy()) 
	      Sleep(10);	
      if(SellStopLoss > 0 || SellTakeProfit > 0) 
         {		
         if(!OrderModify(SellTicket,OpenPrice,SellStopLoss,SellTakeProfit,0))
         Print("Add LimitsSell Failed,order number:",OrderTicket(),"Error:",GetLastError());
         }                    
      }
     
    //+------------------------------------------------------------------------------------------------------------------+   
   //TrailingStop
       
 void Trail()
    {        
     double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;
     double TrailingStop = StopLevel + MinStop * pips2dbl;
                 
      for(int OrderCounter = OrdersTotal()-1; OrderCounter >= 0; OrderCounter--)                   
         {//23
        if(!OrderSelect(OrderCounter,SELECT_BY_POS))continue;
         if(OrderType()== OP_BUY && OrderSymbol()== Symbol() 
            && OrderMagicNumber()== MagicNumber)                                                                        
            {//24
               RefreshRates();
            if(OrderStopLoss() < Bid - (TrailingStop * pips2dbl) && Bid - OrderOpenPrice() > (MinimumProfit * pips2dbl)) 
               {//25
                  RefreshRates();
               if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid - (TrailingStop * pips2dbl), OrderTakeProfit(),0,Yellow))
                Print("Buy TrailingStop Failed, order number:",OrderTicket(),"Error:",GetLastError());
               }//25
             }//24
           }//23          
           if(OrderType()==OP_SELL && OrderSymbol()== Symbol() 
              && OrderMagicNumber()== MagicNumber)
              {//26
                 RefreshRates();
              if(OrderStopLoss() > Ask + (TrailingStop * pips2dbl) && OrderOpenPrice() - Ask > (MinimumProfit * pips2dbl))  
                 {//2
                    RefreshRates();
                 if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask + (TrailingStop * pips2dbl) ,OrderTakeProfit(),0,Yellow))              
                 Print("Sell TrailingStop Failed, order number:",OrderTicket(),"Error:",GetLastError());
               }//27                                         
            return(0);     
          }//26   
    }

 //+------------------------------------------------------------------------------------------------------------------+ 

// GetTicketFromHistory

int GetTicketFromHistory(string sym,int mn,int orderposinhistory=0)
  {
   bool debug=false;
   if(debug)Print("Orders in history: ", OrdersHistoryTotal());
   int ticket,count=1,i;
   datetime orderclosedates[];
   for(i=OrdersHistoryTotal()-1;i>=0;i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
      if(debug)Print("OrderSymbol: ",OrderSymbol(),"; OrderMagicNumber: ",OrderMagicNumber(),
                     " ;OrderType: ",OrderType(),"; OrderTicket: ",OrderTicket(),
                     "; OrderCloseTime: ",TimeToStr(OrderCloseTime()),";"); 
      if((OrderMagicNumber()  ==mn)
         &&(OrderSymbol()     ==sym)
         &&(OrderType()==OP_BUY||OrderType()==OP_SELL))
         {                       
         ArrayResize(orderclosedates,count);
         orderclosedates[count-1]=OrderCloseTime();
         count++;
      }
   }
   if(ArraySize(orderclosedates)> 1)//<--------------------------------------------------------------changed from 0 to 1 in test
   {
      if(debug)Print("ArraySize (Orders found): ",ArraySize(orderclosedates));
      if(ArraySize(orderclosedates)>orderposinhistory)
      {                         
         ArraySort(orderclosedates,WHOLE_ARRAY,0,MODE_DESCEND);
         for(i=OrdersHistoryTotal()-1;i>=0;i--)
         {
            if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
            if(OrderCloseTime()==orderclosedates[orderposinhistory])
            {
               ticket=OrderTicket();
               if(debug)Print("Orderticket for order ",orderposinhistory," in history: ",ticket);
               break;      
            }
         }    
      }
      else
      {
         if(debug)Print("Not enough matching orders in history!");
      }
   }   
   return(ticket);   
}

  //+------------------------------------------------------------------------------------------------------------------+ 
 void OpenOppositeOrder()
    {     
 int Op;  
   for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)
      {//
      if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))continue;          
         {//
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)           
            {//16
             Op = OrderType();
             RefreshRates();            
            if(Op == OP_BUY && Bid < (OrderOpenPrice() - (OppositeDistance*pips2dbl)) && SellAllowed)     
               {//  
                while(IsTradeContextBusy()) 
                      Sleep(10);
                      RefreshRates();                             
                SellTicket = OrderSend(Symbol(), OP_SELL, MLots, Bid, Slippage*pips2points, 0, 0, "Open Opposite Sell Order", MagicNumber, 0, Red);
                if(SellTicket > -1) 
                  {//
                  BuyAllowed=true;SellAllowed=false;                                          
                  Print("Opposite Sell order placed # ", SellTicket);
                  AddLimitsSell();
                  return;
                  }//
               else
                  {//
                  Print("Opposite Sell Order Failed,order number:",OrderTicket(),"Error:",GetLastError());
                  }//
                }// 
                RefreshRates();           
            if(Op == OP_SELL && Ask > (OrderOpenPrice() + (OppositeDistance*pips2dbl)) && BuyAllowed)        
               {//  
               while(IsTradeContextBusy()) 
                    Sleep(10);
	                 RefreshRates();	          	        
               BuyTicket = OrderSend(Symbol(), OP_BUY, MLots, Ask, Slippage*pips2points, 0, 0, " Open Opposite Buy Order", MagicNumber, 0, Green); 
               if(BuyTicket > -1)
                  {//
                  BuyAllowed=false;SellAllowed=true;                                                          
                  Print("Opposite Buy order placed # ", BuyTicket);                  
                  AddLimitsBuy();
                  return;
                  }//
               else
                  {//  
                  Print("Opposite Buy Order Failed, order number:",OrderTicket(),"Error:",GetLastError());
                  }//   
               }//
            }//
         }//    
      }//      
    }//
    
    //+------------------------------------------------------------------------------------------------------------------+ 
   
   void CloseAllOnSL()
   {
   int OrdType, GLError;
   double OrderClosed;
      	
   int LastClosedTicket=GetTicketFromHistory(Symbol(),MagicNumber);  
   if(LastClosedTicket > 0)                                          
      {                                                  
      Print("LastClosedTicket=",LastClosedTicket);                   
      if(OrderSelect(LastClosedTicket,SELECT_BY_TICKET))             
         { 
             
         if(MathAbs(OrderTakeProfit()- OrderClosePrice())>            
            MathAbs(OrderStopLoss()- OrderClosePrice()))CloseAll();
                                 
            {        
            Print("Order with ticketnr: ", LastClosedTicket,
                  " hit SL! Close all open orders");                                   
             } 
          }     
       } 
     }
           
 //+------------------------------------------------------------------------------------------------------------------+   
       
                void CloseOrderInLoss()
                   {
                 int OrderLoss;
                
                 for(int OrderInLoss = OrdersTotal()-1; OrderInLoss >= 0; OrderInLoss--)       
                    if(OrderSelect(OrderInLoss, SELECT_BY_POS, MODE_TRADES)
                       && OrderMagicNumber()== MagicNumber 
                       && OrderSymbol()== Symbol())                                                    
                     {
                     if(OrderProfit() < 0)
                       {
                        CloseAll();
                        break;
                       }	                  	            
                     }               
                   }               
                    
   //+------------------------------------------------------------------------------------------------------------------+ 
            
           void CloseAll()
              {
               int OrdType;
               int GLError;
  
                for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
                if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
                   && OrderMagicNumber()== MagicNumber 
                   && OrderSymbol()== Symbol())                                       
                   {//31
                   OrdType = OrderType();
                   if(OrdType == OP_BUY || OrdType==OP_SELL)
                      {//32
                     while(IsTradeContextBusy()) 
                        Sleep(10);  
	                  RefreshRates();
	            
                     if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),Slippage*pips2points, Yellow))                
                        {
                        GLError = GetLastError();
                        Print("Error Closing Order, error # ", GLError, " for ticket: ", OrderTicket());  
                        }
                      }//32               
                    }//31      
                 }//30 
              
 //+------------------------------------------------------------------------------------------------------------------+ 
 // Check if OK to Open Orders
    bool TradingHours()
 {
  if (DayOfWeek() == 0 && Hour() >= StartHourOnSunday)
  if ((DayOfWeek() == 5 && Hour() <= LastHourOnFriday)) return (true); 
  return (false);
 }           
   
 //+------------------------------------------------------------------------------------------------------------------+         
  
  
 